#include <conio.h>
#include <stdio.h>
#include <math.h>
//#include "A255.h"
#include <stdio.h>          
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#define GRAD2PI (3.14159265359F/180.F)
#define PI 3.14159265359F

void LlegirMatriu(float matriu[3][3]){
	FILE * fitxer;
	char cad[200];
	char *ptrToken;
	int cnt;

	if ((fitxer = fopen ("matriu.txt", "r")) == NULL)
	{ 
		printf ( " Error en la apertura. Es posible que el fichero no exista \n ");
	}

	cnt=0;
	while (fgets(cad,30,fitxer)!=NULL) { //Agafem la seguent linea i la descomposem
		ptrToken = strtok(cad," "); //Obtenim la primera posici de la matriu
		matriu[cnt][0] = atof(ptrToken);
		ptrToken = strtok(NULL," "); //Obtenim la segona posici de la matriu
		matriu[cnt][1] = atof(ptrToken);
		ptrToken = strtok(NULL,""); //Obtenim la tercera posici de la matriu
		matriu[cnt][2] = atof(ptrToken);
		cnt++;
	}
}

int LlegirCentreDeMasses(float peces[20][3]){
	FILE * fitxer;
	char cad[200];
	char *ptrToken;
	int cnt;

	if ((fitxer = fopen ("captura.seg", "r")) == NULL)
	{ 
		printf ( " Error en la apertura. Es posible que el fichero no exista \n ");
	}

	fgets(cad,114,fitxer);  //Saltem la primera linia del fitxer
	cnt=0;
	while (fgets(cad,114,fitxer)!=NULL) {
		ptrToken = strtok(cad,":");
		ptrToken = strtok(NULL," "); //Obtenim les files
		peces[cnt][0] = atof(ptrToken);
		ptrToken = strtok(NULL," "); //Obtenim les columnes
		peces[cnt][1] = atof(ptrToken);
		ptrToken = strtok(NULL," "); //Saltem informaci innecessaria
		ptrToken = strtok(NULL," ");
		ptrToken = strtok(NULL," "); //Obtenim el nmero de taques
		peces[cnt][2] = atof(ptrToken);
		cnt++;
	}

	return cnt;
}


void conversor(float PuntR[6], float matriu[3][3], float fila , float columna, float ntaques,float orientacio)
{
     
	PuntR[0]= matriu[0][0]*fila + matriu[0][1]*columna + matriu[0][2];
	PuntR[1]= matriu[1][0]*fila + matriu[1][1]*columna + matriu[1][2];

    if (ntaques==0){
       PuntR[2]=40.F;
    }
    if (ntaques==1){
       PuntR[2]=47.F;
    }
    if (ntaques==2){
		PuntR[2]=62.F;
	}
	if (ntaques==3){
       PuntR[2]=70.F;
    }
	
    if (ntaques==4){
       PuntR[2]=81.F;
    }

	if (orientacio==1){
	PuntR[3]= (float)(0*90.0)*GRAD2PI;
	}
	if (orientacio==0){
		PuntR[3]= (float)(1*90.0)*GRAD2PI;
	}
	PuntR[4]= 90.F*GRAD2PI;
	PuntR[5]= 0.F*GRAD2PI;

}

int main()
{
	float P0[6], P1[6], P2[6], P3[6];
	float P00[6], P11[6], P22[6], P33[6];
	float PuntR [6];
	float PuntRR [6];
	
	
	float matriu[3][3];
	float peces[20][3];
	int iError;
	int cnt=0;
	int i,j,k,z,trobat;
	int peca;
	float deixar;
	int fi;
	int comp_objectius_col,comp_objectius_fil;
	
float objectius[20][4];

int to[20];
int toaux[20];

int cnt_objectius=0;

int num_nodes=0;
int node_actual=0;
int veinsv=0;
int veinsh=0;
int aux;
int salts;
int saltsaux;
int node_minim;
int orientat;

struct node{
       int id;
       int pare;//si pare=id s l'arrel
       int orientacio;  //0: horitzontal   1: vertical
       int germa;//posici a la taula del germ
       int fillsv;//0 t fills 1 no en te
       int fillsh;//0 t fills 1 no en te
       int treta;//-1: si no ha estat treta  1: si s'ha tret
}t[1000];


Init();
LlegirMatriu(matriu);
cnt = LlegirCentreDeMasses(peces);
deixar=7.F;
fi=0;

for(i=0;i<3;i++){
        printf("Matriu %i",i);
		printf(" %f",matriu[i][0]);
		printf(" %f",matriu[i][1]);
		printf(" %f\n",matriu[i][2]);
}

printf("     FILA  ");
printf("     COLUMNA");
printf("     NUMERO DE TAQUES\n");
	
for(i=0;i<cnt;i++){
		printf("Pea %i",i);
		printf(" %f",peces[i][0]);
		printf(" %f",peces[i][1]);
		printf(" %f\n",peces[i][2]);
}
printf("Escolleix una pea?\n");
	
scanf( "%i", &peca);

//creaci de l'arbre
t[node_actual].id=peca;
t[node_actual].pare=-1;
while (fi==0){
        t[node_actual].fillsv = 0;
        t[node_actual].fillsh = 0;
		//mirem les peces veines en horitzontal
		for (i=0;i<cnt;i++){
			comp_objectius_col = peces[t[node_actual].id][0] - peces[i][0];
			comp_objectius_fil = peces[t[node_actual].id][1] - peces[i][1];

			if (comp_objectius_fil < 0) comp_objectius_fil = (-1)*comp_objectius_fil;
			if (comp_objectius_col < 0) comp_objectius_col = (-1)*comp_objectius_col;

			if ((comp_objectius_col<100) && (comp_objectius_fil<15) && (comp_objectius_col != 0)){
				if(peces[i][2] > peces[t[node_actual].id][2]){
                    num_nodes ++;
                    //printf ("num_nod: %i\n",num_nodes);
                    t[node_actual].fillsh ++;
                    t[num_nodes].id = i;  
                    t[num_nodes].orientacio = 0;          
					t[num_nodes].pare= node_actual;
					t[num_nodes].treta= -1;
				}
			}
		}
		
		//mirem les veines en vertical
		for (i=0;i<cnt;i++){
			comp_objectius_col = peces[t[node_actual].id][0] - peces[i][0];
			comp_objectius_fil = peces[t[node_actual].id][1] - peces[i][1];

			if (comp_objectius_fil < 0) comp_objectius_fil = (-1)*comp_objectius_fil;
			if (comp_objectius_col < 0) comp_objectius_col = (-1)*comp_objectius_col;

			if ((comp_objectius_col<30) && (comp_objectius_fil<100) && (comp_objectius_fil != 0)){
				if(peces[i][2] > peces[t[node_actual].id][2]){
                    if (t[node_actual].fillsh!=0){
                        num_nodes ++;
                        t[num_nodes].id = i;
                        t[num_nodes].orientacio = 1;               
    					t[num_nodes].pare= node_actual;
    					t[num_nodes].treta= -1;
                    }
                        t[node_actual].fillsv ++;
                        
				}
			}
		}
		if (t[node_actual].fillsv==0){
                num_nodes=num_nodes-t[node_actual].fillsh;                      
        }		
		if (num_nodes==node_actual) {
           fi=1;
        }

       node_actual++;
       
}

printf ("========Busquem germans=========\n");
for (i=0;i<node_actual;i++){
t[i].germa=-1;
}
for (i=0;i<node_actual;i++){
      for (j=0;j<node_actual;j++){
            if ((t[i].pare==t[j].pare) && (t[i].id!=t[j].id) && (t[i].orientacio==t[j].orientacio)){
                      t[i].germa=j;
                      t[j].germa=i;                                     
            }                
      }                      
}
printf ("========Arbre=========\n");
for (i=0;i<node_actual;i++){
       printf ("PECA: %i\n",t[i].id);
       j=t[i].pare;
       if (j!=-1){
       printf ("Pare: %i\n",t[j].id);
       }
       printf ("orientacio: %i\n",t[i].orientacio);
       printf ("fills vertical: %i\n",t[i].fillsv);
       printf ("fills horitzontal: %i\n",t[i].fillsh);
       j=t[i].germa;
       if (j!=-1){
       printf ("germa: %i\n",t[j].id);
       }
}

printf ("================TAULAAAAA=================\n");
for (i=0;i<node_actual;i++){
       printf ("PECA: %i\n",t[i].id);
       printf ("germa: %i\n",t[i].germa);
}
printf ("================PARES=================\n");
for (i=0;i<node_actual;i++){
       printf ("pare: %i\n",t[i].pare);
}
printf ("================SOLUCIO=================\n");
i=node_actual-1;

fi=0;
node_minim=i;//posici de la taula del node mnim per on comencem a treure peces
salts=1000;//salts del node mnim
saltsaux=0;//salts auxiliar
k=i;
while (fi==0){
     i=k;
     saltsaux=0;
     if (t[k].fillsv==0 || t[k].fillsh==0){
            while (t[i].id!=peca){
                 saltsaux++;
                 t[i].treta=1;
                 printf ("TREC: %i\n",t[i].id);
                 toaux[saltsaux-1]=i;
                 if (t[i].germa==-1){
                    i=t[i].pare;
                 }else{
                     j=t[i].germa;
                     if (t[j].treta==1) {
                            i=t[i].pare;                     
                     }else{
                           if (t[j].fillsv==0 || t[j].fillsh==0 ){
                              i=t[i].germa;
                           }else{
                           //cas en que el germ t fills
                           //si el germ t fills busquem a la dreta nodes en que el pare sigui el germ
                               
                               j=i;
                               trobat=0;
                                   while (j<node_actual && trobat==0){
                          
                                           if (t[j].pare==t[i].germa && t[j].treta==-1){
                                                          if (t[j].fillsv==0 || t[j].fillsh==0){
                                                           i=j;
                                                           trobat=1;
                                                          }else{
                                                            //si t fills busquem els fills dels fills cap a la dreta
                                                            for (z=j;z<node_actual;z++){
                                                                if (t[z].pare==j && t[z].treta==-1){
                                                                   if (t[z].fillsv==0 || t[z].fillsh==0){
                                                                      i=z;
                                                                   }else{
                                                                         i=z;
                                                                   }
                                                                }else{
                                                                      i=z;
                                                                }
                                                            
                                                            }
                                                            
                                                          }
                                           }else{
                                              if (j==node_actual){
                                                 i=j;
                                              }
                                           }
                                           j++;
                                   }
                           
                           }
                           
                     
                     }              
                                      
                 
                 }
             }  
             //mirem si el nmero de salts s inferior al que teniem
             if (saltsaux<salts){
                salts=saltsaux;
                node_minim=k;
                for (z=0;z<salts;z++){
                    to[z]=toaux[z];
                }
             }
         
         }
         printf ("Nmero de salts %i\n",saltsaux);
         if (k==0){
                 fi=1;
             }else{
                 k=k-1;
                 for (j=0;j<node_actual;j++){
                     t[j].treta=-1;
                 }
             }

}
                          
printf ("SOLUCIO:\n");

if(salts>0){
	printf ("PEA: %i\n",t[to[0]].id);

	if (t[to[0]].fillsv==0){
		printf ("orientacio: %i\n",1);
		orientat=1;
	}else{
		printf ("orientacio: %i\n",0);
		orientat=0;
	}
	   conversor(P0, matriu, 69.F, deixar,peces[t[to[0]].id][2],0);
       conversor(P00, matriu, 69.F, deixar,0,0);
       P00[2]=200.F;
	   printf ("PEACOL: %f\n",peces[t[to[0]].id][0]);
	   printf ("PEAFIL: %f\n",peces[t[to[0]].id][1]);
       conversor(PuntR, matriu, peces[t[to[0]].id][0], peces[t[to[0]].id][1], peces[t[to[0]].id][2],orientat);
       conversor(PuntRR, matriu, peces[t[to[0]].id][0], peces[t[to[0]].id][1], peces[t[to[0]].id][2],orientat);
       PuntRR[2]=300.F;
			
        iError= Carrega_Location("P0",P0);
		iError= Carrega_Location("P00",P00);
		iError= Carrega_Location("P1",PuntR);
		iError= Carrega_Location("P11",PuntRR);
		iError= Carrega_Programa("TREURE");
		ModeAscii();
		iError= Exec_Comanda("RUN TREURE");
		deixar=deixar+100;
}

for (i=1;i<salts;i++){
       z=to[i];
       printf ("PEA: %i\n",t[z].id);
	   printf ("PEACOL: %f\n",peces[t[z].id][0]);
		printf ("PEAFIL: %f\n",peces[t[z].id][1]);
       if (t[to[i-1]].pare==z){
               printf ("orientacio: %i\n",t[to[i-1]].orientacio);
               orientat=t[to[i-1]].orientacio;
       }else{  
                   if (t[z].fillsv==0 && t[z].fillsh!=0){
                      printf ("orientacio: %i\n",1);
                      orientat=1;
                   }else{
                         if (t[z].fillsh==0 && t[z].fillsv!=0){
                            printf ("orientacio: %i\n",0);
                            orientat=0;
                         }else{
                               
                               printf ("qualsevol orientacio serveix: %i\n",0);
                               orientat=0;
                         }
                   }
               
       }

       conversor(P0, matriu, 69.F, deixar,peces[t[z].id][2],0);
       conversor(P00, matriu, 69.F, deixar,0,0);
       P00[2]=200.F;
       conversor(PuntR, matriu, peces[t[z].id][0], peces[t[z].id][1], peces[t[z].id][2],orientat);
       conversor(PuntRR, matriu, peces[t[z].id][0], peces[t[z].id][1], peces[t[z].id][2],orientat);
       PuntRR[2]=300.F;
			
        iError= Carrega_Location("P0",P0);
		iError= Carrega_Location("P00",P00);
		iError= Carrega_Location("P1",PuntR);
		iError= Carrega_Location("P11",PuntRR);
		iError= Carrega_Programa("TREURE");
		ModeAscii();
		iError= Exec_Comanda("RUN TREURE");
       deixar=deixar+100;
       
}


if (salts>0){
printf ("PECA: %i\n",t[0].id);
printf ("orientacio: %i\n",t[to[salts-1]].orientacio);
orientat=t[to[salts-1]].orientacio;
}else{
printf ("PECA: %i\n",t[0].id);
if (t[z].fillsv==0){
      printf ("orientacio: %i\n",1);
      orientat=1;
}else{
      printf ("orientacio: %i\n",0);
      orientat=0;
      }
}
conversor(P0, matriu, 69.F, deixar,peces[t[0].id][2],0);
conversor(P00, matriu, 69.F, deixar,0,0);
P00[2]=200.F;
conversor(PuntR, matriu, peces[t[0].id][0], peces[t[0].id][1], peces[t[0].id][2],orientat);
conversor(PuntRR, matriu, peces[t[0].id][0], peces[t[0].id][1], peces[t[0].id][2],orientat);
PuntRR[2]=300.F;
			
iError= Carrega_Location("P0",P0);
iError= Carrega_Location("P00",P00);
iError= Carrega_Location("P1",PuntR);
iError= Carrega_Location("P11",PuntRR);
iError= Carrega_Programa("TREURE");
ModeAscii();
iError= Exec_Comanda("RUN TREURE");
Final();

return 1;
}
